;*****************************************************************************************
;	innterrupt api
;*****************************************************************************************


INT0_SET_LOW:										; set interrupt 0 source to low
		in		Temp, MCUCR
		andi	Temp, 0b11111100						; set int. to low level
		out		MCUCR, Temp
		ret

INT0_EN:											; enable int0
		cli
		ldi		Temp, 0b01000000
		out		GIFR, Temp								; clear any existing flag
		in		Temp, GIMSK
		ori		Temp, 0b01000000
		out		GIMSK, Temp
		sei
		ret

INT0_DIS:											; disable int0
		cli
		in		Temp, GIMSK
		andi	Temp, 0b10111111						; clear the enable
		out		GIMSK, Temp
		sei
		ret

ACT_SLEEP:											; activate the sleep mode
		in		Temp, MCUCR
		ori		Temp, 0b00110000
		out		MCUCR, Temp
		;sleep
		ret

DIS_SLEEP:											; disable the sleep mode
		in		Temp, MCUCR
		andi	Temp, 0b11001111
		out		MCUCR, Temp
		ret

INT0ROUTINE:										; int0 isr
		rcall	DIS_SLEEP
		rcall	INT0_DIS								; disable the interrupt
		reti
