;api for timer routines of tiny12

;********** Timer 0

.ifdef prescaltmr0
 .ifndef Temp
		.def	Temp	=	r16
 .endif
TMR0_SET_PRESCAL:									; set the timer prescaler
		in		Temp, TCCR0
		andi	Temp, 0b11111000						; reset the prescaler bits
		.if prescaltmr0==0
		;clr		Temp								; load the prescaler value
		.elif prescaltmr0==1
		ori		Temp, 0x01
		.elif prescaltmr0==8
		ori		Temp, 0x02
		.elif prescaltmr0==64
		ori		Temp, 0x03
		.elif prescaltmr0==256
		ori		Temp, 0x04
		.elif prescaltmr0==1024
		ori		Temp, 0x05
		.elif prescaltmr0==1100
		ori		Temp, 0x06
		.elif prescaltmr0==0011
		ori		Temp, 0x07
		.else
		 .error "invalid TMR0 prescaler value (0 1 8 64 256 1024 1100 0011)"
		.endif
		out		TCCR0, Temp
		ret
.endif

TMR0_EN_OVF:
		ldi		Temp, 0x02
		out		TIFR, TEMP								; clear any existing flag
		out		TIMSK, TEMP								; enable the interrupt
		ret

TMR0_DIS_OVF:
		clr		Temp
		out		TIMSK, TEMP
		ret

TMR0_START:											; reset the timer counter and start the timer
		clr		Temp
		out		TCNT0, Temp
		rjmp	TMR0_EN_OVF
